/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2009  Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Sam Lantinga
    slouken@libsdl.org
*/
#include "SDL_config.h"

#include "SDL_QuartzVideo.h"
#include "SDL_QuartzWM.h"
#include "SDL_QuartzWindow.h"

static float gWinWidth = 0;
static float gWinHeight = 0;

/*
    This function makes the *SDL region* of the window 100% opaque. 
    The genie effect uses the alpha component. Otherwise,
    it doesn't seem to matter what value it has.
*/
//static void QZ_SetPortAlphaOpaque () {
//    printf("WTF\n");
//    SDL_Surface *surface = current_video->screen;
//    int bpp;
//    
//    bpp = surface->format->BitsPerPixel;
//    
//    if (bpp == 32) {
//    
//        Uint32    *pixels = (Uint32*) surface->pixels;
//        Uint32    rowPixels = surface->pitch / 4;
//        Uint32    i, j;
//        
//        for (i = 0; i < surface->h; i++)
//            for (j = 0; j < surface->w; j++) {
//        
//                pixels[ (i * rowPixels) + j ] |= 0xFF000000;
//            }
//    }
//}

//@implementation SDL_QuartzWindow

///* we override these methods to fix the miniaturize animation/dock icon bug */
//- (void)miniaturize:(id)sender
//{
////    if (SDL_VideoSurface->flags & SDL_OPENGL) {
////    
////        /* 
////            Future: Grab framebuffer and put into NSImage
////            [ qz_window setMiniwindowImage:image ];
////        */
////    }
////    else {
////        
////        /* make the alpha channel opaque so anim won't have holes in it */
////        QZ_SetPortAlphaOpaque ();
////    }
////    
//    /* window is hidden now */
//    SDL_PrivateAppActive (0, SDL_APPACTIVE);
////
//    [ super miniaturize:sender ];
//}

//- (void)display
//{    
////    /* 
////        This method fires just before the window deminaturizes from the Dock.
////        
////        We'll save the current visible surface, let the window manager redraw any
////        UI elements, and restore the SDL surface. This way, no expose event 
////        is required, and the deminiaturize works perfectly.
////    */
////     SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
////    
////    /* make sure pixels are fully opaque */
////    if (! ( SDL_VideoSurface->flags & SDL_OPENGL ) )
////        QZ_SetPortAlphaOpaque ();
////    
////    /* save current visible SDL surface */
////    [ self cacheImageInRect:[ window_view frame ] ];
////    
//    /* let the window manager redraw controls, border, etc */
//    [ super display ];
////    
////    /* restore visible SDL surface */
////    [ self restoreCachedImage ];
////    
//    /* window is visible again */
//    SDL_PrivateAppActive (1, SDL_APPACTIVE);
//}

//- (void)setFrame:(NSRect)frameRect display:(BOOL)flag
//{
////    static int foof = 0;
////    printf("WOULD SET FRAME %d\n",foof++);
////    [ super setFrame:frameRect display:flag ];
////    return;
//    /*
//        If the video surface is NULL, this originated from QZ_SetVideoMode,
//        so don't send the resize event. 
//    */
//    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
//    
//    if (this && SDL_VideoSurface == NULL) {
//
//        [ super setFrame:frameRect display:flag ];
//    }
//    else if (this && qz_window) {
//
//        NSRect newViewFrame;
//        
//        [ super setFrame:frameRect display:flag ];
//        
//        newViewFrame = [ window_view frame ];
//        
//        SDL_PrivateResize (newViewFrame.size.width, newViewFrame.size.height);
//        
//        // ericf addition
//        [ gl_context update];
//
//    }
//}

/* QZ_DoActivate() calls a low-level CoreGraphics routine to adjust
   the cursor position, if input is being grabbed. If app activation is
   triggered by a mouse click in the title bar, then the window manager
   gets confused and thinks we're dragging the window. The solution
//   below postpones the activate event to avoid this scenario. */
//- (void)becomeKeyWindow
//{
//	NSEvent *event = [self currentEvent];
//	if ([event type] == NSLeftMouseDown && [event window] == self)
//		watchForMouseUp = YES;
//	else
//		[super becomeKeyWindow];
//}
//
//- (void)sendEvent:(NSEvent *)event
//{
//	[super sendEvent:event];
//	if (watchForMouseUp && [event type] == NSLeftMouseUp)
//	{
//		watchForMouseUp = NO;
//		[super becomeKeyWindow];
//	}
//}
//
//- (void)appDidHide:(NSNotification*)note
//{
//    SDL_PrivateAppActive (0, SDL_APPACTIVE);
//}

//- (void)appWillUnhide:(NSNotification*)note
//{
//    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
//    
////    if ( this ) {
//    
//        /* make sure pixels are fully opaque */
////        if (! ( SDL_VideoSurface->flags & SDL_OPENGL ) )
////            QZ_SetPortAlphaOpaque ();
////          
////        /* save current visible SDL surface */
////        [ self cacheImageInRect:[ window_view frame ] ];
////    }
//}

//- (void)appDidUnhide:(NSNotification*)note
//{
//    /* restore cached image, since it may not be current, post expose event too */
//    [ self restoreCachedImage ];
//    
//    /*SDL_PrivateExpose ();*/
//    
//    SDL_PrivateAppActive (1, SDL_APPACTIVE);
//}

//- (id)initWithContentRect:(NSRect)contentRect styleMask:(NSUInteger)styleMask backing:(NSBackingStoreType)backingType defer:(BOOL)flag
//{
//    /* Make our window subclass receive these application notifications */
//    [ [ NSNotificationCenter defaultCenter ] addObserver:self
//        selector:@selector(appDidHide:) name:NSApplicationDidHideNotification object:NSApp ];
//    
//    [ [ NSNotificationCenter defaultCenter ] addObserver:self
//        selector:@selector(appDidUnhide:) name:NSApplicationDidUnhideNotification object:NSApp ];
//   
//    [ [ NSNotificationCenter defaultCenter ] addObserver:self
//        selector:@selector(appWillUnhide:) name:NSApplicationWillUnhideNotification object:NSApp ];
//        
//    return [ super initWithContentRect:contentRect styleMask:styleMask backing:backingType defer:flag ];
//}

//@end

int gMacScreenInTransition=0;


@implementation SDL_QuartzWindowDelegate
- (BOOL)windowShouldClose:(id)sender
{
    SDL_PrivateQuit();
    return NO;
}

// we store this state in a simple int as opposed to looking it up live
// so that its thread-safe-ish to do so
//int gIsFullscreen = false;


// lets set these on both will-enter and did-enter
// will-enter allows us to draw full-screen specific stuff immediately
// and did-enter is just to be sure
- (void)windowWillEnterFullScreen:(NSNotification *)notification
{
    gMacScreenInTransition = true;
    //gIsFullscreen = true;

//    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
//    if (!(this && qz_window && window_view && SDL_VideoSurface != NULL)) return;
//
//    NSRect backingBounds = [window_view convertRectToBacking:[window_view bounds]];
//    if ((backingBounds.size.width != gWinWidth) || (backingBounds.size.height != gWinHeight)){
//        printf("CHANGEFOO IN DRAWRECT from %f to %f\n",gWinWidth,backingBounds.size.width);
//        gWinWidth = backingBounds.size.width;
//        gWinHeight = backingBounds.size.height;
//        SDL_PrivateResize (backingBounds.size.width, backingBounds.size.height);
//    }
//
//
//    // now tell bombsquad to draw a frame..
//    // (RESIZEDRAW simply specifies that it should ignore regular draw events for
//    // a short while after this; keeps resizing smooth)
//    {
//    SDL_Event event;
//    event.motion.type = SDL_DRAWEVENT;
//    SDL_PushEvent(&event);
//    }

    SDL_Event event;
    memset(&event, 0, sizeof(event));
    event.type = SDL_FULLSCREENSWITCH;
    event.user.code = true;
    SDL_PushEvent(&event);

}

- (void)windowDidEnterFullScreen:(NSNotification *)notification
{
    gMacScreenInTransition=false;
}

- (void)windowWillExitFullScreen:(NSNotification *)notification
{
    gMacScreenInTransition=true;


    //gIsFullscreen = false;
    
    SDL_Event event;
    memset(&event, 0, sizeof(event));
    event.type = SDL_FULLSCREENSWITCH;
    event.user.code = false;
    SDL_PushEvent(&event);

}
- (void)windowDidExitFullScreen:(NSNotification *)notification
{
    gMacScreenInTransition = false;
}


//- (void)windowDidEnterFullScreen:(NSNotification *)notification
//{
//    gIsFullscreen = true;
//}
//- (void)windowDidExitFullScreen:(NSNotification *)notification
//{
//    gIsFullscreen = false;
//}
//

- (void)windowDidBecomeKey:(NSNotification *)aNotification
{
    QZ_DoActivate (current_video);
}

- (void)windowDidResignKey:(NSNotification *)aNotification
{
    QZ_DoDeactivate (current_video);
}

@end

@implementation SDL_QuartzView

-(id) initWithFrame: (NSRect) frameRect
{
    
    NSOpenGLPixelFormatAttribute attrs[] =
    {
        NSOpenGLPFADoubleBuffer,
        NSOpenGLPFADepthSize,
        16,
        0
    };
    
    NSOpenGLPixelFormat *fmt;
    fmt = [ [ NSOpenGLPixelFormat alloc ] initWithAttributes:attrs ];
    if (fmt == nil) {
        abort();
        return 0;
    }

	//NSOpenGLPixelFormat * pf = [BasicOpenGLView basicPixelFormat];
    
	self = [super initWithFrame: frameRect pixelFormat: fmt];
    [self setWantsBestResolutionOpenGLSurface:YES];
    
    [ fmt release ];

    return self;
}

- (void)mouseDown:(NSEvent *)theEvent
{
    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!this) return;
    QZ_DoModifiers(this, [ theEvent modifierFlags ] );
    NSPoint location = [theEvent locationInWindow];// = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    QZ_PrivateCocoaToSDL(this,&location);
    //printf("MOUSE DOWN %f %f\n",location.x,location.y);
    SDL_PrivateMouseButton (SDL_PRESSED, SDL_BUTTON_LEFT, location.x, location.y);          \

}

//int SDL_ericf_isFullscreen(){
//    return gIsFullscreen;
//}

- (void)mouseUp:(NSEvent *)theEvent
{
    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!this) return;
    QZ_DoModifiers(this, [ theEvent modifierFlags ] );
    NSPoint location = [theEvent locationInWindow];// = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    QZ_PrivateCocoaToSDL(this,&location);

    //NSPoint location = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    //printf("MOUSE UP %f %f\n",location.x,location.y);
    SDL_PrivateMouseButton (SDL_RELEASED, SDL_BUTTON_LEFT, location.x,location.y);          \

}

- (void)mouseDragged:(NSEvent *)theEvent {
    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!this) return;
    QZ_DoModifiers(this, [ theEvent modifierFlags ] );
    NSPoint location = [theEvent locationInWindow];// = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    QZ_PrivateCocoaToSDL(this,&location);
    SDL_PrivateMouseMotion (0, 0, location.x, location.y);
}

extern void QZ_DoKey (_THIS, int state, NSEvent *event);

void _gameCenterDialogDismissWorkaround();

- (void)keyDown:(NSEvent *)theEvent {

    // ewww there's currently (as of 10.8.2) an issue on game-center where the escape key
    // dismisses the dialog instead of informing us that we should,
    // leaving the rest of our UI in a locked state.
    // ..so if we're receiving key events we can assume the dialog is gone and clean up as best we can
    _gameCenterDialogDismissWorkaround();

    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!this) return;
    
    // we ignore anything while the command key is pressed.. OSX sends
    // keyDown events to us for these but no keyUp, so it messes up our
    // repeats if we do.
    if( ([theEvent modifierFlags] & NSDeviceIndependentModifierFlagsMask)
       == NSCommandKeyMask) return;

    QZ_DoModifiers(this, [ theEvent modifierFlags ] );
    QZ_DoKey (this, SDL_PRESSED, theEvent);

}

extern void QZ_DoModifiers (_THIS, unsigned int newMods);

- (void)flagsChanged:(NSEvent *)theEvent {
    //printf("FLAGCHANGE\n");
    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!this) return;

    QZ_DoModifiers(this, [ theEvent modifierFlags ] );
    //printf("modchanged\n");
}

//- (BOOL) performKeyEquivalent: (NSEvent*) anEvent
//{
//    // we don't want these sent to our
//    printf("DOING KEY EQUIV\n");
//    return FALSE;
//}

- (void)keyUp:(NSEvent *)theEvent {
    //printf("KEYUP\n");
    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!this) return;
    QZ_DoModifiers(this, [ theEvent modifierFlags ] );
    QZ_DoKey (this, SDL_RELEASED, theEvent);

}

- (void)scrollWheel:(NSEvent *)theEvent{
//    if (theEvent.deltaY != 0.0 || theEvent.deltaX != 0.0)
//        printf("SCROLL WHEEL %f\n",theEvent.deltaY);
    SDL_Event event;
    memset(&event, 0, sizeof(event));
    event.type = SDL_SMOOTHSCROLLEVENT;
    //printf("MOMENTUM %d\n",momentum);
    //printf("PHASE %lu\n",theEvent.momentumPhase);
    event.scroll.deltaX = theEvent.scrollingDeltaX;
    event.scroll.deltaY = theEvent.scrollingDeltaY;
    event.scroll.momentum = (theEvent.momentumPhase != NSEventPhaseNone
                             && theEvent.momentumPhase != NSEventPhaseEnded
                             && theEvent.momentumPhase != NSEventPhaseCancelled);
    //printf("SCROLL %f\n",theEvent.scrollingDeltaY);
    SDL_PushEvent(&event);

}

- (void)mouseMoved:(NSEvent *)theEvent {

    // ewww there's currently (as of 10.8.2) an issue on game-center where the escape key
    // dismisses the dialog instead of informing us that we should,
    // leaving the rest of our UI in a locked state.
    // ..so if we're receiving mouse-moved events we can assume the dialog is gone and clean up as best we can
    static int foo = 0;
    foo++;
    if (foo > 10){
        _gameCenterDialogDismissWorkaround();
        foo = 0;
    }

    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!this) return;
    QZ_DoModifiers(this, [ theEvent modifierFlags ] );
    NSPoint location = [theEvent locationInWindow];// = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    QZ_PrivateCocoaToSDL(this,&location);
    SDL_PrivateMouseMotion (0, 0, location.x, location.y);
}


- (void) update
{
    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!(this && qz_window && SDL_VideoSurface != NULL)) return;

	//NSRect rectView = [self bounds];
    //printf("UPDATE!\n");
    //NSRect newViewFrame = [ self frame ];
    NSRect backingBounds = [self convertRectToBacking:[self bounds]];
    if ((backingBounds.size.width != gWinWidth) || (backingBounds.size.height != gWinHeight)){
        //printf("CHANGE1 IN DRAWRECT from %f to %f\n",gWinWidth,backingBounds.size.width);
        gWinWidth = backingBounds.size.width;
        gWinHeight = backingBounds.size.height;
        SDL_PrivateResize (backingBounds.size.width, backingBounds.size.height);
    }
//gWinWidth = backingBounds.size.width;
//    gWinHeight = backingBounds.size.height;
//    SDL_PrivateResize (backingBounds.size.width, backingBounds.size.height);

    [ super update];

}

- (void) drawRect:(NSRect)rect
{
    SDL_VideoDevice *this = (SDL_VideoDevice*)current_video;
    if (!(this && qz_window && SDL_VideoSurface != NULL)) return;
        
        //NSRect newViewFrame;
        
        //[ super setFrame:frameRect display:flag ];
        
        //NSRect newViewFrame = [ self frame ];
        //printf("UPDATE2 %f %f\n",newViewFrame.size.width,newViewFrame.size.height);
        //SDL_PrivateResize (newViewFrame.size.width, newViewFrame.size.height);
        
        // ericf addition
        //[ gl_context update];
    
    //}

    NSRect backingBounds = [self convertRectToBacking:[self bounds]];
    if ((backingBounds.size.width != gWinWidth) || (backingBounds.size.height != gWinHeight)){
        //printf("CHANGE2 IN DRAWRECT from %f to %f\n",gWinWidth,backingBounds.size.width);
        gWinWidth = backingBounds.size.width;
        gWinHeight = backingBounds.size.height;
        SDL_PrivateResize (backingBounds.size.width, backingBounds.size.height);
    }

    
    // now tell bombsquad to draw a frame..
    // (RESIZEDRAW simply specifies that it should ignore regular draw events for
    // a short while after this; keeps resizing smooth)
    SDL_Event event;
    event.motion.type = SDL_RESIZEDRAWEVENT;
    SDL_PushEvent(&event);
}

- (void)resetCursorRects
{
    SDL_Cursor *sdlc = SDL_GetCursor();
    if (sdlc != NULL && sdlc->wm_cursor != NULL) {
        [self addCursorRect: [self visibleRect] cursor: sdlc->wm_cursor->nscursor];
    }
}

@end
